## API Report File for "@fluidframework/shared-object-base"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { EventEmitterEventType } from '@fluid-internal/client-utils';
import { EventEmitterWithErrorHandling } from '@fluidframework/telemetry-utils';
import { IChannel } from '@fluidframework/datastore-definitions';
import { IChannelAttributes } from '@fluidframework/datastore-definitions';
import { IChannelServices } from '@fluidframework/datastore-definitions';
import { IChannelStorageService } from '@fluidframework/datastore-definitions';
import { IErrorEvent } from '@fluidframework/core-interfaces';
import { IEventProvider } from '@fluidframework/core-interfaces';
import { IEventThisPlaceHolder } from '@fluidframework/core-interfaces';
import { IExperimentalIncrementalSummaryContext } from '@fluidframework/runtime-definitions';
import { IFluidDataStoreRuntime } from '@fluidframework/datastore-definitions';
import { IFluidHandle } from '@fluidframework/core-interfaces';
import { IFluidHandleContext } from '@fluidframework/core-interfaces';
import { IGarbageCollectionData } from '@fluidframework/runtime-definitions';
import { ISequencedDocumentMessage } from '@fluidframework/protocol-definitions';
import { ISummaryTreeWithStats } from '@fluidframework/runtime-definitions';
import { ITelemetryContext } from '@fluidframework/runtime-definitions';
import { ITelemetryLoggerExt } from '@fluidframework/telemetry-utils';

// @internal
export function createSingleBlobSummary(key: string, content: string | Uint8Array): ISummaryTreeWithStats;

// @internal
export class FluidSerializer implements IFluidSerializer {
    constructor(context: IFluidHandleContext, handleParsedCb?: (handle: IFluidHandle) => void);
    decode(input: any): any;
    encode(input: any, bind: IFluidHandle): any;
    // (undocumented)
    get IFluidSerializer(): this;
    // (undocumented)
    parse(input: string): any;
    // (undocumented)
    protected serializeHandle(handle: IFluidHandle, bind: IFluidHandle): {
        type: string;
        url: string;
    };
    // (undocumented)
    stringify(input: any, bind: IFluidHandle): string;
}

// @public (undocumented)
export interface IFluidSerializer {
    decode(input: any): any;
    encode(value: any, bind: IFluidHandle): any;
    parse(value: string): any;
    stringify(value: any, bind: IFluidHandle): string;
}

// @public
export interface ISharedObject<TEvent extends ISharedObjectEvents = ISharedObjectEvents> extends IChannel, IEventProvider<TEvent> {
    bindToContext(): void;
    getGCData(fullGC?: boolean): IGarbageCollectionData;
}

// @public
export interface ISharedObjectEvents extends IErrorEvent {
    // @eventProperty
    (event: "pre-op", listener: (op: ISequencedDocumentMessage, local: boolean, target: IEventThisPlaceHolder) => void): any;
    // @eventProperty
    (event: "op", listener: (op: ISequencedDocumentMessage, local: boolean, target: IEventThisPlaceHolder) => void): any;
}

// @alpha
export function makeHandlesSerializable(value: any, serializer: IFluidSerializer, bind: IFluidHandle): any;

// @alpha
export function parseHandles(value: any, serializer: IFluidSerializer): any;

// @internal
export function serializeHandles(value: any, serializer: IFluidSerializer, bind: IFluidHandle): string | undefined;

// @public
export abstract class SharedObject<TEvent extends ISharedObjectEvents = ISharedObjectEvents> extends SharedObjectCore<TEvent> {
    constructor(id: string, runtime: IFluidDataStoreRuntime, attributes: IChannelAttributes, telemetryContextPrefix: string);
    // (undocumented)
    getAttachSummary(fullTree?: boolean, trackState?: boolean, telemetryContext?: ITelemetryContext): ISummaryTreeWithStats;
    getGCData(fullGC?: boolean): IGarbageCollectionData;
    protected processGCDataCore(serializer: IFluidSerializer): void;
    // (undocumented)
    protected get serializer(): IFluidSerializer;
    // (undocumented)
    summarize(fullTree?: boolean, trackState?: boolean, telemetryContext?: ITelemetryContext, incrementalSummaryContext?: IExperimentalIncrementalSummaryContext): Promise<ISummaryTreeWithStats>;
    protected abstract summarizeCore(serializer: IFluidSerializer, telemetryContext?: ITelemetryContext, incrementalSummaryContext?: IExperimentalIncrementalSummaryContext): ISummaryTreeWithStats;
}

// @public
export abstract class SharedObjectCore<TEvent extends ISharedObjectEvents = ISharedObjectEvents> extends EventEmitterWithErrorHandling<TEvent> implements ISharedObject<TEvent> {
    constructor(id: string, runtime: IFluidDataStoreRuntime, attributes: IChannelAttributes);
    protected abstract applyStashedOp(content: any): unknown;
    // (undocumented)
    readonly attributes: IChannelAttributes;
    bindToContext(): void;
    // (undocumented)
    connect(services: IChannelServices): void;
    get connected(): boolean;
    protected didAttach(): void;
    protected dirty(): void;
    emit(event: EventEmitterEventType, ...args: any[]): boolean;
    // (undocumented)
    abstract getAttachSummary(fullTree?: boolean, trackState?: boolean, telemetryContext?: ITelemetryContext): ISummaryTreeWithStats;
    abstract getGCData(fullGC?: boolean): IGarbageCollectionData;
    readonly handle: IFluidHandle;
    protected handleDecoded(decodedHandle: IFluidHandle): void;
    // (undocumented)
    id: string;
    // (undocumented)
    get IFluidLoadable(): this;
    initializeLocal(): void;
    protected initializeLocalCore(): void;
    // (undocumented)
    isAttached(): boolean;
    load(services: IChannelServices): Promise<void>;
    protected abstract loadCore(services: IChannelStorageService): Promise<void>;
    protected readonly logger: ITelemetryLoggerExt;
    protected newAckBasedPromise<T>(executor: (resolve: (value: T | PromiseLike<T>) => void, reject: (reason?: any) => void) => void): Promise<T>;
    protected onConnect(): void;
    protected abstract onDisconnect(): any;
    protected abstract processCore(message: ISequencedDocumentMessage, local: boolean, localOpMetadata: unknown): any;
    protected reSubmitCore(content: any, localOpMetadata: unknown): void;
    protected rollback(content: any, localOpMetadata: unknown): void;
    // (undocumented)
    protected runtime: IFluidDataStoreRuntime;
    protected submitLocalMessage(content: any, localOpMetadata?: unknown): void;
    // (undocumented)
    abstract summarize(fullTree?: boolean, trackState?: boolean, telemetryContext?: ITelemetryContext): Promise<ISummaryTreeWithStats>;
}

// @internal
export class SummarySerializer extends FluidSerializer {
    // (undocumented)
    getSerializedRoutes(): string[];
    // (undocumented)
    protected serializeHandle(handle: IFluidHandle, bind: IFluidHandle): {
        type: string;
        url: string;
    };
}

// @internal
export enum ValueType {
    Plain = 1,
    // @deprecated
    Shared = 0
}

// (No @packageDocumentation comment for this package)

```
